Web/Controllers/GroupController.cs
using AutoMapper;
using Domain;
using Microsoft.AspNetCore.Mvc;
using Service;
using Web.Models.GroupModels;
using X.PagedList;

namespace Web.Controllers
{
    public class GroupController : Controller
    {

        private readonly IGroupService _groupService;
        private readonly IMapper _appMappingProfile;
        public GroupController(IGroupService groupService, IMapper appMappingProfile)
        {
            _groupService = groupService ?? throw new ArgumentNullException(nameof(groupService));
            _appMappingProfile = appMappingProfile ?? throw new ArgumentNullException(nameof(appMappingProfile));
        }

        public IActionResult Index(int? page, int? courseId)
        {
            int pageSize = 3;
            int pageNumber = 1;
            if (page != null && page > 0)
            {
                pageNumber = (int)page;
            }
            if (courseId != null)
            {
                return this.LoadIndexWithGroup(pageNumber, (int)courseId, pageSize);
            }
            return this.LoadIndexWithAllGroup(pageNumber, pageSize);
        }

        private IActionResult LoadIndexWithAllGroup(int pageNumber, int pageSize)
        {
            List<GroupViewEditAddModel> groupViewModels = _appMappingProfile.Map<List<GroupViewEditAddModel>>(_groupService.GetAll());
            GroupPagedViewModel groupPagedViewModel = new();
            groupPagedViewModel.CourseId = null;
            groupPagedViewModel.GroupViewEditAddModels = groupViewModels.ToPagedList<GroupViewEditAddModel>(pageNumber, pageSize);
            return View("Index", groupPagedViewModel);
        }

        private IActionResult LoadIndexWithGroup(int pageNumber, int courseId, int pageSize)
        {
            List<GroupViewEditAddModel> groupViewModels = _appMappingProfile.Map<List<GroupViewEditAddModel>>(_groupService.GetGroupsByCourse(courseId));
            GroupPagedViewModel groupPagedViewModel = new();
            groupPagedViewModel.CourseId = courseId;
            groupPagedViewModel.GroupViewEditAddModels = groupViewModels.ToPagedList<GroupViewEditAddModel>(pageNumber, pageSize);
            return View("Index", groupPagedViewModel);
        }
        [HttpGet]
        public IActionResult Add(int courseId)
        {
            GroupViewEditAddModel groupViewAddModel = new();
            groupViewAddModel.CourseId = courseId;
            return View("_AddFormGroups", groupViewAddModel);

        }

        [HttpPost]
        public IActionResult AddGroup(GroupViewEditAddModel groupViewAddModel)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Index", new { courseId = groupViewAddModel.CourseId });
            }
            Group group = _appMappingProfile.Map<Group>(groupViewAddModel);
            _groupService.AddGroup(group);
            return RedirectToAction("Index", new { courseId = groupViewAddModel.CourseId });
        }


        public IActionResult Delete(int id)
        {
            if (!_groupService.GroupExist(id))
            {
                return RedirectToAction("Index");

            }
            Group group = _groupService.GetGroup(id);
            if (group.Students != null && group.Students.Any())
            {
                TempData.Add("Error", "First, remove the students from the group");
                return RedirectToAction("Index", new { courseId = group.CourseId });

            }
            _groupService.RemoveGroup(id);
            return RedirectToAction("Index", new { courseId = group.CourseId });
        }


        [HttpGet]
        public IActionResult Edit(int id)
        {
            if (!_groupService.GroupExist(id))
            {
                return View("Index");
            }
            GroupViewEditAddModel groupViewAddModel = _appMappingProfile.Map<GroupViewEditAddModel>(_groupService.GetGroup(id));
            return View("_EditFormGroups", groupViewAddModel);
        }


        [HttpPost]
        public IActionResult EditGroup(GroupViewEditAddModel groupViewEditAddModel)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Index", new { courseId = groupViewEditAddModel.CourseId });
            }
            _groupService.UpdateGroup(_appMappingProfile.Map<Group>(groupViewEditAddModel));
            return RedirectToAction("Index", new { courseId = groupViewEditAddModel.CourseId });

        }


    }
}

Web/Controllers/StudentController.cs
using AutoMapper;
using Domain;
using Microsoft.AspNetCore.Mvc;
using Service;
using Web.Models.StudentModels;
using X.PagedList;
using IHostingEnvironment = Microsoft.AspNetCore.Hosting.IHostingEnvironment;
namespace Web.Controllers
{
    public class StudentController : Controller
    {
        private readonly IStudentService _studentService;
        private readonly IMapper _appMappingProfile;
        private readonly IHostingEnvironment _hostingEnvironment;

        public StudentController(IStudentService studentService, IMapper appMappingProfile, IHostingEnvironment hostingEnvironment)
        {
            _studentService = studentService ?? throw new ArgumentNullException(nameof(studentService));
            _appMappingProfile = appMappingProfile ?? throw new ArgumentNullException(nameof(appMappingProfile));
            _hostingEnvironment = hostingEnvironment ?? throw new ArgumentNullException(nameof(hostingEnvironment));
        }
        public IActionResult Index(int? page, int? groupId)
        {
            int pageSize = 3;
            int pageNumber = 1;
            if (page != null && page > 0)
            {
                pageNumber = (int)page;
            }
            if (groupId != null)
            {
                return this.LoadIndexWithStudents(pageNumber, (int)groupId, pageSize);
            }
            return this.LoadIndexWithAllStudents(pageNumber, pageSize);
        }



        private IActionResult LoadIndexWithAllStudents(int pageNumber, int pageSize)
        {
            List<StudentViewModel> studentViewModels = _appMappingProfile.Map<List<StudentViewModel>>(_studentService.GetAll());
            StudentPagedViewModel studentPagedViewModel = new();
            studentPagedViewModel.GroupId = null;
            studentPagedViewModel.StudentViewModels = studentViewModels.ToPagedList<StudentViewModel>(pageNumber, pageSize);
            return View("Index", studentPagedViewModel);
        }

        private IActionResult LoadIndexWithStudents(int pageNumber, int groupId, int pageSize)
        {
            List<StudentViewModel> studentViewModels = _appMappingProfile.Map<List<StudentViewModel>>(_studentService.GetStudentsByGroup(groupId));
            StudentPagedViewModel studentPagedViewModel = new();
            studentPagedViewModel.GroupId = groupId;
            studentPagedViewModel.StudentViewModels = studentViewModels.ToPagedList<StudentViewModel>(pageNumber, pageSize);
            return View("Index", studentPagedViewModel);
        }

        [HttpGet]
        public IActionResult Add(int groupId)
        {
            StudentAddModel studentAddModel = new();
            studentAddModel.GroupId = groupId;
            return View("_AddFormStudents", studentAddModel);

        }


        [HttpPost]
        public IActionResult AddStudent(StudentAddModel studentAddModel)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Index", new { groupId = studentAddModel.GroupId });
            }
            Student student = _appMappingProfile.Map<Student>(studentAddModel);
            student.FilePath = this.UploadModelFileToServer(studentAddModel);
            _studentService.AddStudent(student);
            return RedirectToAction("Index", new { groupId = studentAddModel.GroupId });
        }


        public IActionResult Delete(int id)
        {
            if (!_studentService.StudentExist(id))
            {
                return RedirectToAction("Index");
            }
            Student student = _studentService.GetStudent(id);

            string filePath = student.FilePath;
            this.DeleteModelFolder(filePath);
            _studentService.RemoveStudent(id);
            return RedirectToAction("Index", new { groupId = student.GroupId });
        }


        [HttpGet]
        public IActionResult Edit(int id)
        {
            if (!_studentService.StudentExist(id))
            {
                return RedirectToAction("Index");
            }
            StudentEditModel studentEditModel = _appMappingProfile.Map<StudentEditModel>(_studentService.GetStudent(id));
            return View("_EditFormStudents", studentEditModel);
        }


        [HttpPost]
        public IActionResult EditStudent(StudentEditModel studentEditModel)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Index", new { groupId = studentEditModel.GroupId });
            }
            Student student = _appMappingProfile.Map<Student>(studentEditModel);
            student.FilePath = this.EditModelFileInServer(studentEditModel);
            _studentService.UpdateStudent(student);
            return RedirectToAction("Index", new { studentEditModel.GroupId });

        }
        private string UploadModelFileToServer(StudentAddModel studentAddModel)
        {
            if (!ModelState.IsValid)
            {
                return "Model is not valit";
            }
            string path = Path.Combine(_hostingEnvironment.WebRootPath, "img", "student", $"{studentAddModel.FirstName}_{studentAddModel.LastName}");
            Directory.CreateDirectory(path);
            path = Path.Combine(path, studentAddModel.FormFile.FileName);
            using (var stream = System.IO.File.Create(path))
            {
                studentAddModel.FormFile.CopyTo(stream);
            }
            return Path.Combine(Path.AltDirectorySeparatorChar.ToString(), "img", "student", $"{studentAddModel.FirstName}_{studentAddModel.LastName}", studentAddModel.FormFile.FileName);
        }

        private string EditModelFileInServer(StudentEditModel studentEditModel)
        {
            if (!ModelState.IsValid)
            {
                return "Model is not valit";
            }
            string filePath = _studentService.GetStudentThatNoTracking(studentEditModel.Id).FilePath;

            if (studentEditModel.FormFile != null)
            {
                this.DeleteModelFolder(filePath);
                filePath = this.UploadModelFileToServer(_appMappingProfile.Map<StudentAddModel>(studentEditModel));
            }
            return filePath;
        }
        private void DeleteModelFolder(string path)
        {
            if (string.IsNullOrEmpty(path))
            {
                return;
            }
            path = Path.GetFullPath(_hostingEnvironment.WebRootPath + path);
            if (System.IO.File.Exists(path))
            {
                Directory.Delete(Path.GetDirectoryName(path), true);
            }
        }
    }
}

Web/Views/Group/Index.cshtml
@using X.PagedList.Mvc.Core;
@using X.PagedList.Mvc.Common;
@using X.PagedList;

@model Web.Models.GroupModels.GroupPagedViewModel;

@{
    ViewData["Title"] = "Group Page";
    ViewData["Header"] = "Groups";
}


<div class="container text-center">

    <div class="row">
        <div class="col-sm-14 h1">
            @if (Model.CourseId != null)
            {
                <div>Group</div>
            }else{
                <div>All Group</div>
            }
            
        </div>
    </div>

    <div class="row">
        @foreach (var item in Model.GroupViewEditAddModels)
        {
            <div class="col">
                <div class="card bg-light">
                    <div class="row=">                      
                        <div class="col">
                            <div class="card-body">
                                <h5 class="card-title">@item.Name</h5>
                                <p class="card-text">@item.Description</p>
                                <a href="@Url.Action("Index","Student", new{ groupId = item.Id },null )" class="btn btn-primary">See students</a>
                                <a href="@Url.Action("Edit","Group", new{ id = item.Id},null )" class="btn btn-primary">Edit</a> 
                                <a href="@Url.Action("Delete","Group" , new{ id = item.Id},null )" class="btn btn-primary">Remove</a>
                            </div>
                            <span class="bg-danger">@TempData["Error"]</span>

                        </div>

                    </div>
                </div>
            </div>
        }
    </div>
    <div class="row">
        <div class="col">
            @(Model.GroupViewEditAddModels.PageCount < Model.GroupViewEditAddModels.PageNumber ? 0 : Model.GroupViewEditAddModels.PageNumber) of @Model.GroupViewEditAddModels.PageCount
            @Html.PagedListPager((IPagedList)Model.GroupViewEditAddModels, page => Url.Action("Index", new {page , courseId = Model.CourseId}) ,
            new X.PagedList.Web.Common.PagedListRenderOptions{
            LiElementClasses = new string[]{"page-item"},
            PageClasses = new string[]{"page-link"},
            UlElementClasses = new string[] {"pagination justify-content-center"}

            })
            @if (Model.CourseId != null)
            {
                <a class="btn btn-primary" id="add-button" href="@Url.Action("Add","Group" , new {courseId = Model.CourseId})">Add new</a>
            }
        </div>

    </div>
</div>

Web/Views/Group/_AddFormGroups.cshtml
@model Web.Models.GroupModels.GroupViewEditAddModel;
@*Add form*@
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">

<div class="bg-light text-center">
    @using (Html.BeginForm("AddGroup", "Group", FormMethod.Post))
    {
        <h3>Add new course</h3>
        <div class="mb-3 mt-3">
            @Html.LabelFor(model => model.Name,null,new { htmlAttributes = new { @class = "form-label" } })
            @Html.EditorFor(model => model.Name,new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name)
        </div>
        <div class="mb-3">
            @Html.LabelFor(model => model.Description,null,new { htmlAttributes = new { @class = "form-label" }})
            @Html.EditorFor(model => model.Description,new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description)

        </div>
        <div class="mb-3">
            @Html.HiddenFor(model => model.CourseId)
        </div>
        <button type="submit" class="btn btn-primary">Send</button>
    }

</div>

@await Html.PartialAsync("_ValidationScriptsPartial")

Web/Views/Group/_EditFormGroups.cshtml
@model Web.Models.GroupModels.GroupViewEditAddModel;
@*Add form*@
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">



<div class="bg-light text-center">
    @using (Html.BeginForm("EditGroup", "Group", FormMethod.Post))
    {
        <h3>Edit group</h3>
        @Html.HiddenFor(model => model.Id);
        @Html.HiddenFor(model => model.CourseId);
        <div class="mb-3 mt-3">
            @Html.LabelFor(model => model.Name,null,new { htmlAttributes = new { @class = "form-label" } })
            @Html.EditorFor(model => model.Name,new { htmlAttributes = new { @class = "form-control" } })
        </div>
        <div class="mb-3">
            @Html.LabelFor(model => model.Description,null,new { htmlAttributes = new { @class = "form-label" }})
            @Html.EditorFor(model => model.Description,new { htmlAttributes = new { @class = "form-control" } })
        </div>
        
        <button type="submit" class="btn btn-primary">Send</button>
    }

</div>

@await Html.PartialAsync("_ValidationScriptsPartial")